'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcSlider = require('rc-slider');

var _rcSlider2 = _interopRequireDefault(_rcSlider);

var _rcInputNumber = require('rc-input-number');

var _rcInputNumber2 = _interopRequireDefault(_rcInputNumber);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _colorlab = require('colorlab');

var _colorlab2 = _interopRequireDefault(_colorlab);

require('rc-slider/assets/index.css');

var _picker = require('./picker.css');

var _picker2 = _interopRequireDefault(_picker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Lab = function (_Component) {
  _inherits(Lab, _Component);

  function Lab(props, context) {
    _classCallCheck(this, Lab);

    var _this = _possibleConstructorReturn(this, (Lab.__proto__ || Object.getPrototypeOf(Lab)).call(this, props, context));

    _this.onUpdate = function () {
      if (_this.props.onUpdate) {
        _this.props.onUpdate({
          L: _this.state.L,
          a: _this.state.a,
          b: _this.state.b
        });
      }
    };

    _this.onLInputChange = function (value) {
      if (value === undefined) {
        _this.setState({ L: 0 }, _this.onUpdate);
        return;
      }
      var newValue = parseFloat(value);
      if (!isNaN(newValue)) {
        _this.setState({ L: newValue }, _this.onUpdate);
      }
    };

    _this.onAInputChange = function (value) {
      if (value === undefined) {
        _this.setState({ a: 0 }, _this.onUpdate);
        return;
      }
      var newValue = parseFloat(value);
      if (!isNaN(newValue)) {
        _this.setState({ a: newValue }, _this.onUpdate);
      }
    };

    _this.onBInputChange = function (value) {
      if (value === undefined) {
        _this.setState({ b: 0 }, _this.onUpdate);
        return;
      }
      var newValue = parseFloat(value);
      if (!isNaN(newValue)) {
        _this.setState({ b: newValue }, _this.onUpdate);
      }
    };

    _this.onLSliderChange = function (L) {
      _this.setState({ L: L }, _this.onUpdate);
    };

    _this.onASliderChange = function (a) {
      _this.setState({ a: a }, _this.onUpdate);
    };

    _this.onBSliderChange = function (b) {
      _this.setState({ b: b }, _this.onUpdate);
    };

    _this.cssGradient = function (LColorMin, LColorMax) {
      var css = 'linear-gradient(to right';
      var i = void 0;
      var steps = 9;
      for (i = 0; i < steps; i += 1) {
        var color = LColorMax.interpolate(LColorMin, i / (steps - 1)).toSRGB().toHexString();
        css += ', ' + color + ' ' + i / (steps - 1) * 100 + '%';
      }

      css += ')';
      return css;
    };

    _this.state = {
      L: _this.props.L || 50,
      a: _this.props.a || 0,
      b: _this.props.b || 0
    };
    return _this;
  }

  _createClass(Lab, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        L: nextProps.L,
        a: nextProps.a,
        b: nextProps.b
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          L = _state.L,
          a = _state.a,
          b = _state.b;

      var color = new _colorlab2.default.CIELAB(L, a, b);
      var handleStyle = {
        height: 28,
        width: 28,
        marginLeft: -14,
        marginTop: -10,
        borderColor: '#999'
      };

      var LStyle = {
        backgroundImage: this.cssGradient(new _colorlab2.default.CIELAB(0, a, b), new _colorlab2.default.CIELAB(100, a, b)),
        height: 8
      };

      var aStyle = {
        backgroundImage: this.cssGradient(new _colorlab2.default.CIELAB(L, -128, b), new _colorlab2.default.CIELAB(L, 128, b)),
        height: 8
      };

      var bStyle = {
        backgroundImage: this.cssGradient(new _colorlab2.default.CIELAB(L, a, -128), new _colorlab2.default.CIELAB(L, a, 128)),
        height: 8
      };

      return _react2.default.createElement(
        'div',
        { className: '' },
        _react2.default.createElement(
          'div',
          { className: _picker2.default.container },
          _react2.default.createElement(
            'div',
            { className: _picker2.default.caption },
            'L'
          ),
          _react2.default.createElement(
            'div',
            { className: _picker2.default.slider },
            _react2.default.createElement(_rcSlider2.default, {
              tipTransitionName: 'rc-slider-tooltip-zoom-down',
              maximumTrackStyle: LStyle,
              minimumTrackStyle: { backgroundColor: 'transparent' },
              handleStyle: handleStyle,
              value: L,
              min: 0,
              max: +100,
              onChange: this.onLSliderChange
            })
          ),
          _react2.default.createElement(
            'div',
            { className: _picker2.default.input },
            _react2.default.createElement(_rcInputNumber2.default, {
              value: L,
              min: 0,
              max: 100,
              step: 1,
              onChange: this.onLInputChange
            })
          )
        ),
        _react2.default.createElement(
          'div',
          { className: _picker2.default.container },
          _react2.default.createElement(
            'div',
            { className: _picker2.default.caption },
            'a'
          ),
          _react2.default.createElement(
            'div',
            { className: _picker2.default.slider },
            _react2.default.createElement(_rcSlider2.default, {
              tipTransitionName: 'rc-slider-tooltip-zoom-down',
              maximumTrackStyle: aStyle,
              minimumTrackStyle: { backgroundColor: 'transparent' },
              handleStyle: handleStyle,
              value: a,
              min: -128,
              max: +128,
              onChange: this.onASliderChange
            })
          ),
          _react2.default.createElement(
            'div',
            { className: _picker2.default.input },
            _react2.default.createElement(_rcInputNumber2.default, {
              value: a,
              min: -128,
              max: +128,
              step: 1,
              onChange: this.onAInputChange
            })
          )
        ),
        _react2.default.createElement(
          'div',
          { className: _picker2.default.container },
          _react2.default.createElement(
            'div',
            { className: _picker2.default.caption },
            'b'
          ),
          _react2.default.createElement(
            'div',
            { className: _picker2.default.slider },
            _react2.default.createElement(_rcSlider2.default, {
              tipTransitionName: 'rc-slider-tooltip-zoom-down',
              maximumTrackStyle: bStyle,
              minimumTrackStyle: { backgroundColor: 'transparent' },
              handleStyle: handleStyle,
              value: b,
              min: -128,
              max: +128,
              onChange: this.onBSliderChange
            })
          ),
          _react2.default.createElement(
            'div',
            { className: _picker2.default.input },
            _react2.default.createElement(_rcInputNumber2.default, {
              value: b,
              min: -128,
              max: +128,
              step: 1,
              onChange: this.onBInputChange
            })
          )
        ),
        _react2.default.createElement('div', {
          className: _picker2.default.testpatch,
          style: {
            backgroundColor: color.toSRGB().toHexString()
          }
        })
      );
    }
  }]);

  return Lab;
}(_react.Component);

Lab.defaultProps = {
  onUpdate: function onUpdate() {}
};
exports.default = Lab;
Lab.propTypes = process.env.NODE_ENV !== "production" ? {
  L: _propTypes2.default.number.isRequired,
  a: _propTypes2.default.number.isRequired,
  b: _propTypes2.default.number.isRequired,
  onUpdate: _propTypes2.default.func
} : {};